/* jQuery Carousel 0.9.
Copyright 2010 Thomas Lanciaux and Pierre Bertet.
This software is licensed under the CC-GNU LGPL <http://creativecommons.org/licenses/LGPL/2.1/>
*/
;(function($){
    
    $.fn.carousel = function(params){
        
        var params = $.extend({
            direction: "horizontal",
            loop: false,
            dispItems: 1,
            pagination: false,
            paginationPosition: "inside",
            nextBtn: '<div></div>',
            prevBtn: '<div></div>',
            btnsPosition: "inside",
            nextBtnInsert: "insertAfter",
            prevBtnInsert: "insertBefore",
            nextBtnInsertFn: false,
            prevBtnInsertFn: false,
            autoSlide: false,
            autoSlideInterval: 3000,
            delayAutoSlide: false,
            combinedClasses: false,
            effect: "slide",
            slideEasing: "easeInOutExpo",
            animSpeed: 700,
            equalWidths: true,
            verticalMargin: 0,
            callback: function () {},
            completeAnimate: function() {},
            useAddress: false,
            adressIdentifier: "carousel",
            tabLabel: function (tabNum) { return tabNum; },
            showEmptyItems: false,
            ajaxMode:false,
            ajaxUrl:"",
            stopSlideBtn: false,
            stopSlideTextPause: "Pause",
            stopSlideTextPlay: "Play"
        }, params);
        
        // Buttons position
        if (params.btnsPosition == "outside"){
            params.prevBtnInsert = "insertBefore";
            params.nextBtnInsert = "insertAfter";
        }
        
        // Slide delay
        params.delayAutoSlide = 0 + params.delayAutoSlide;
        
        return this.each(function(){
	        var deswidget = false;
	        if ($(this).hasClass('deswidget') || $(this).parents('.textwidget').length) deswidget = true;
            // Env object
            var env = {
                $elts: {},
                params: params,
                launchOnLoad: [],
                widget: deswidget 
            };
            
            var rtime = new Date(1, 1, 2000, 12,00,00);
			var timeout = false;
			var delta = 1000;
            
            if (!isMobile.any() && $('#disable_responsive_layout').html() == "off"){
	         	$(window).resize(function(){
	            	rtime = new Date();
	            	if (timeout === false) {
				        timeout = true;
				        setTimeout(resizeend, delta);
				    }
	            	var columns = false;
			        var windowWidth = $(window).width();
		            
		            if (env.widget){
			            if (env.$elts.carousel.closest('.eight.columns').length){
				            env.$elts.content.children().each(function(){
					            if (windowWidth < 480)
				            		$(this).css('width', Math.floor((env.$elts.carousel.closest('.eight.columns').outerWidth())-5));
				            	else
						            $(this).css('width', Math.floor((env.$elts.carousel.closest('.eight.columns').outerWidth() / 2)-5));
				            });
				            columns = true;
			            }
			            if (env.$elts.carousel.closest('.one-third.column').length){
				            env.$elts.content.children().each(function(){
					            if (windowWidth < 768 && windowWidth > 480){
						            $(this).css('width', Math.floor((env.$elts.carousel.closest('.one-third.column').outerWidth() / 2)-5));   
					            } else {
						            $(this).css('width', Math.floor((env.$elts.carousel.closest('.one-third.column').outerWidth())-5));
					            }
				            });
				            columns = true;
			            }
			            if (env.$elts.carousel.closest('.two-thirds.column').length){
				            env.$elts.content.children().each(function(){
					         	if (windowWidth < 480)
				            		$(this).css('width', Math.floor((env.$elts.carousel.closest('.two-thirds.column').outerWidth())-5));
				            	else {
						            $(this).css('width', Math.floor((env.$elts.carousel.closest('.two-thirds.column').outerWidth() / 2)-5));
						            if ($(this).closest('section').is('.recentProjects3')){
					            		$(this).width($(this).width()-5);
							        }
						        }   
				            });
				            columns = true;
			            }
			            
			            if (env.$elts.carousel.closest('.four.columns').length){
				            env.$elts.content.children().each(function(){
			            		$(this).css('width', Math.floor((env.$elts.carousel.closest('.four.columns').outerWidth())-5));
				            });
				            columns = true;
			            }
			            
			            if (env.$elts.carousel.closest('.twelve.columns').length){
				            env.$elts.content.children().each(function(){
				            	if (env.$elts.carousel.closest('section').is('.recentProjects4')){
					            	if (windowWidth < 480)
					            		$(this).css('width', Math.floor((env.$elts.carousel.closest('.twelve.columns').outerWidth())-5));
					            	if (windowWidth < 768 && windowWidth > 479)
							            $(this).css('width', Math.floor((env.$elts.carousel.closest('.twelve.columns').outerWidth() / 2)-5));
							        if (windowWidth > 767 && windowWidth < 960)
								        $(this).css('width', Math.floor((env.$elts.carousel.closest('.twelve.columns').outerWidth() / 3)-5));
							        if (windowWidth > 959)
							        	$(this).css('width', Math.floor((env.$elts.carousel.closest('.twelve.columns').outerWidth() / 3)-5));	
				            	} else {
					            	if (windowWidth < 480)
					            		$(this).css('width', Math.floor((env.$elts.carousel.closest('.twelve.columns').outerWidth())-10));
					            	if (windowWidth < 768 && windowWidth > 479)
							            $(this).css('width', Math.floor((env.$elts.carousel.closest('.twelve.columns').outerWidth() / 2)-10));
							        if (windowWidth > 767 && windowWidth < 960)
								        $(this).css('width', Math.floor((env.$elts.carousel.closest('.twelve.columns').outerWidth() / 3)-10));
							        if (windowWidth > 959)
							        	$(this).css('width', Math.floor((env.$elts.carousel.closest('.twelve.columns').outerWidth() / 3)-10));	
				            	}
				            });
				            columns = true;
			            }
		            } else {
			            if (env.$elts.carousel.closest('.wpb_column').hasClass('vc_span6')){
				            env.$elts.content.children().each(function(){
					            if (windowWidth < 480)
				            		$(this).css('width', Math.floor((env.$elts.carousel.closest('.vc_span6').outerWidth())-5));
				            	else
					            	$(this).css('width', Math.floor((env.$elts.carousel.closest('.vc_span6').outerWidth() / 2)-5));
				            });
				            columns = true;
			            }
			            if (env.$elts.carousel.closest('.wpb_column').hasClass('vc_span4')){
				            env.$elts.content.children().each(function(){
					            if (windowWidth < 768 && windowWidth > 480){
						            $(this).css('width', Math.floor((env.$elts.carousel.closest('.vc_span4').outerWidth() / 2)-5));   
					            } else {
						            $(this).css('width', Math.floor((env.$elts.carousel.closest('.vc_span4').outerWidth())-5));
					            }
				            });
				            columns = true;
			            }
			            if (env.$elts.carousel.closest('.wpb_column').hasClass('vc_span8')){
				            env.$elts.content.children().each(function(){
					         	if (windowWidth < 480)
				            		$(this).css('width', Math.floor((env.$elts.carousel.closest('.vc_span8').outerWidth())-5));
				            	else {
						            $(this).css('width', Math.floor((env.$elts.carousel.closest('.vc_span8').outerWidth() / 2)-5));
						            if ($(this).closest('section').is('.recentProjects3')){
					            		$(this).width($(this).width()-5);
							        }
						        }
				            });
				            columns = true;
			            }
			            
			            if (env.$elts.carousel.closest('.wpb_column').hasClass('vc_span3')){
				            env.$elts.content.children().each(function(){
			            		$(this).css('width', Math.floor((env.$elts.carousel.closest('.vc_span3').outerWidth())-5));
				            });
				            columns = true;
			            }
			            
			            if (env.$elts.carousel.closest('.wpb_column').hasClass('vc_span9')){
				            env.$elts.content.children().each(function(){
				            	if (env.$elts.carousel.closest('section').is('.recentProjects4')){
					            	if (windowWidth < 480)
					            		$(this).css('width', Math.floor((env.$elts.carousel.closest('.vc_span9').outerWidth())-5));
					            	if (windowWidth < 768 && windowWidth > 479)
							            $(this).css('width', Math.floor((env.$elts.carousel.closest('.vc_span9').outerWidth() / 2)-5));
							        if (windowWidth > 767 && windowWidth < 960)
								        $(this).css('width', Math.floor((env.$elts.carousel.closest('.vc_span9').outerWidth() / 3)-5));
							        if (windowWidth > 959)
							        	$(this).css('width', Math.floor((env.$elts.carousel.closest('.vc_span9').outerWidth() / 3)-5));	
				            	} else {
					            	if (windowWidth < 480)
					            		$(this).css('width', Math.floor((env.$elts.carousel.closest('.vc_span9').outerWidth())-10));
					            	if (windowWidth < 768 && windowWidth > 479)
							            $(this).css('width', Math.floor((env.$elts.carousel.closest('.vc_span9').outerWidth() / 2)-10));
							        if (windowWidth > 767 && windowWidth < 960)
								        $(this).css('width', Math.floor((env.$elts.carousel.closest('.vc_span9').outerWidth() / 3)-10));
							        if (windowWidth > 959)
							        	$(this).css('width', Math.floor((env.$elts.carousel.closest('.vc_span9').outerWidth() / 3)-10));	
				            	}
				            });
				            columns = true;
			            }
		            }
		            
		            if (!columns){
		            	
				        if (!env.$elts.carousel.closest('section').is('.recent_testimonials') && !env.$elts.carousel.closest('section').is('.shortcode-partners')){
				        	
				        	if (env.$elts.carousel.closest('section').is('.recentProjects3')){
					        	env.$elts.content.children().each(function(){
						            if (windowWidth < 480)
					            		$(this).css('width', Math.floor((env.$elts.carousel.closest('section').outerWidth())-10));
					            	if (windowWidth < 768 && windowWidth > 479)
							            $(this).css('width', Math.floor((env.$elts.carousel.closest('section').outerWidth() / 2)-10));
							        if (windowWidth > 767 && windowWidth < 960)
								        $(this).css('width', Math.floor((env.$elts.carousel.closest('section').outerWidth() / 3)-10));
							        if (windowWidth > 959)
							        	$(this).css('width', Math.floor((env.$elts.carousel.closest('section').outerWidth() / 4)-10));
					            });
				        	} else {
					    		env.$elts.content.children().each(function(){
						            var factor = 0;
					    			if (env.widget) factor = 5;
						    		if (windowWidth < 480)
					            		$(this).css('width', Math.floor((env.$elts.carousel.closest('section').outerWidth())-factor));
					            	if (windowWidth < 768 && windowWidth > 479)
							            $(this).css('width', Math.floor((env.$elts.carousel.closest('section').outerWidth() / 2)-factor));
							        if (windowWidth > 767 && windowWidth < 960)
								        $(this).css('width', Math.floor((env.$elts.carousel.closest('section').outerWidth() / 3)-factor));
							        if (windowWidth > 959)
							        	$(this).css('width', Math.floor((env.$elts.carousel.closest('section').outerWidth() / 4)-factor));
					            });    	
				        	}
				        
				        } else {
				        	env.$elts.carousel.closest('section').children().wrapAll('<div class="sixteen columns"/>').removeAttr('style');
					     	env.$elts.content.children().each(function(){
						        if (env.$elts.carousel.closest('section').is('.shortcode-partners')){
							        if (windowWidth < 480)
					            		$(this).css('width', Math.floor((env.$elts.carousel.closest('section').outerWidth())-5));
					            	if (windowWidth < 768 && windowWidth > 479)
							            $(this).css('width', Math.floor((env.$elts.carousel.closest('section').outerWidth() / 2)-7));
							        if (windowWidth > 767 && windowWidth < 960)
								        $(this).css('width', Math.floor((env.$elts.carousel.closest('section').outerWidth() / 3)-12));
							        if (windowWidth > 959)
							        	$(this).css('width', Math.floor((env.$elts.carousel.closest('section').outerWidth() / 4)-12));
						        } 
						        if (env.$elts.carousel.closest('section').is('.recent_testimonials')){
							        if (windowWidth < 480)
					            		$(this).css('width', Math.floor((env.$elts.carousel.closest('section').outerWidth())-10));
					            	if (windowWidth < 768 && windowWidth > 479)
							            $(this).css('width', Math.floor((env.$elts.carousel.closest('section').outerWidth())-10));
							        if (windowWidth > 767 && windowWidth < 960)
								        $(this).css('width', Math.floor((env.$elts.carousel.closest('section').outerWidth())-16));
							        if (windowWidth > 959)
							        	$(this).css('width', Math.floor((env.$elts.carousel.closest('section').outerWidth() / 2)-15));
						        }
				            });  
				        }
		            } else {
			            if (env.$elts.carousel.closest('section').is('.recent_testimonials')){
				            env.$elts.content.children().each(function(){
					            $(this).css('width', Math.floor((env.$elts.carousel.closest('section').outerWidth())-5)).css('margin-right','5px');
				            });
			            }
		            }
		            
		            var ratio = .75;
		            if (env.$elts.carousel.closest('section').is('.recentProjects3')){
			        	env.$elts.content.children().each(function(){
			        		if (!env.$elts.carousel.closest('section').is('.container')){
				        		$(this).css('width', $(this).width() - 5);	
			        		} else {
				        		$(this).css('width', $(this).width() - 5);	
			        		}
			        		$(this).height('auto');
			        		$(this).find('.ch-grid li ').css('height', Math.round($(this).width() * ratio));
			        		$(this).parents('.carousel-wrap').css('height',$(this).height());
				        });    
		            }
		            
		            if (env.$elts.carousel.closest('section').is('.recentProjects4')){
			        	env.$elts.content.children().each(function(){
			        		if (!env.$elts.carousel.closest('section').is('.container')){
				        		$(this).css('width', $(this).width() - 11);	
			        		}
			        		$(this).find('li a').css('height', Math.round($(this).width() * ratio));
				        });    
		            } 
		            initCarousel(env);
	            });   
            }
            
            function resizeend() {
			    if (new Date() - rtime < delta) {
			        setTimeout(resizeend, delta);
			    } else {
			        timeout = false;
			        env.$elts.prevBtn.trigger('click');
			    }               
			}
                   
            // Carousel main container
            env.$elts.carousel = $(this).addClass("js");
            
            // Carousel content
            env.$elts.content = $(this).children().css({position: "absolute", "top": 0});
            
            // Content wrapper
            env.$elts.wrap = env.$elts.content.wrap('<div class="carousel-wrap"></div>').parent().css({overflow: "hidden", position: "relative", width: "100%"});
            
            // env.steps object
            env.steps = {
                first: 0, // First step
                count: env.$elts.content.children().length // Items count
            };
            
            var columns = false;
	        var windowWidth = $(window).width();
	        
	        if (env.widget){ 
	        	//env.$elts.carousel.closest('.wpb_text_column').addClass('rmv');
	        	//env.$elts.carousel.closest('.rmv').removeClass('wpb_content_element').removeClass('wpb_text_column');

	        	//env.$elts.content.width(env.$elts.content.width()+3);
		    	if (env.$elts.carousel.closest('.eight.columns').length){
		            env.$elts.content.children().each(function(){
			            if (windowWidth < 480)
		            		$(this).css('width', Math.floor((env.$elts.carousel.closest('.eight.columns').outerWidth())-5));
		            	else
				            $(this).css('width', Math.floor((env.$elts.carousel.closest('.eight.columns').outerWidth() / 2)-5));
		            });
		            columns = true;
	            }
	            if (env.$elts.carousel.closest('.one-third.column').length){
		            env.$elts.content.children().each(function(){
			            if (windowWidth < 768 && windowWidth > 480){
				            $(this).css('width', Math.floor((env.$elts.carousel.closest('.one-third.column').outerWidth() / 2)-5));   
			            } else {
				            $(this).css('width', Math.floor((env.$elts.carousel.closest('.one-third.column').outerWidth())-5));
			            }
		            });
		            columns = true;
	            }
	            if (env.$elts.carousel.closest('.two-thirds.column').length){
		            env.$elts.content.children().each(function(){
			         	if (windowWidth < 480)
		            		$(this).css('width', Math.floor((env.$elts.carousel.closest('.two-thirds.column').outerWidth())-5));
		            	else {
				            $(this).css('width', Math.floor((env.$elts.carousel.closest('.two-thirds.column').outerWidth() / 2)-5));
				            if ($(this).closest('section').is('.recentProjects3')){
			            		$(this).width($(this).width()-5);
					        }
				        }   
		            });
		            columns = true;
	            }
	            
	            if (env.$elts.carousel.closest('.four.columns').length){
		            env.$elts.content.children().each(function(){
	            		$(this).css('width', Math.floor((env.$elts.carousel.closest('.four.columns').outerWidth())-5));
		            });
		            columns = true;
	            }
	            
	            if (env.$elts.carousel.closest('.twelve.columns').length){
		            env.$elts.content.children().each(function(){
		            	if (env.$elts.carousel.closest('section').is('.recentProjects4')){
			            	if (windowWidth < 480)
			            		$(this).css('width', Math.floor((env.$elts.carousel.closest('.twelve.columns').outerWidth())-5));
			            	if (windowWidth < 768 && windowWidth > 479)
					            $(this).css('width', Math.floor((env.$elts.carousel.closest('.twelve.columns').outerWidth() / 2)-5));
					        if (windowWidth > 767 && windowWidth < 960)
						        $(this).css('width', Math.floor((env.$elts.carousel.closest('.twelve.columns').outerWidth() / 3)-5));
					        if (windowWidth > 959)
					        	$(this).css('width', Math.floor((env.$elts.carousel.closest('.twelve.columns').outerWidth() / 3)-5));	
		            	} else {
			            	if (windowWidth < 480)
			            		$(this).css('width', Math.floor((env.$elts.carousel.closest('.twelve.columns').outerWidth())-10));
			            	if (windowWidth < 768 && windowWidth > 479)
					            $(this).css('width', Math.floor((env.$elts.carousel.closest('.twelve.columns').outerWidth() / 2)-10));
					        if (windowWidth > 767 && windowWidth < 960)
						        $(this).css('width', Math.floor((env.$elts.carousel.closest('.twelve.columns').outerWidth() / 3)-10));
					        if (windowWidth > 959)
					        	$(this).css('width', Math.floor((env.$elts.carousel.closest('.twelve.columns').outerWidth() / 3)-10));	
		            	}
		            });
		            columns = true;
	            }    
	        } else {
				if (env.$elts.carousel.closest('.wpb_column').hasClass('vc_span6')){
		            env.$elts.content.children().each(function(){
			            if (windowWidth < 480)
		            		$(this).css('width', Math.floor((env.$elts.carousel.closest('.vc_span6').outerWidth())-5));
		            	else
			            	$(this).css('width', Math.floor((env.$elts.carousel.closest('.vc_span6').outerWidth() / 2)-5));
		            });
		            columns = true;
	            }
	            if (env.$elts.carousel.closest('.wpb_column').hasClass('vc_span4')){
		            env.$elts.content.children().each(function(){
			            if (windowWidth < 768 && windowWidth > 480){
				            $(this).css('width', Math.floor((env.$elts.carousel.closest('.vc_span4').outerWidth() / 2)-5));   
			            } else {
				            $(this).css('width', Math.floor((env.$elts.carousel.closest('.vc_span4').outerWidth())-5));
			            }
		            });
		            columns = true;
	            }
	            if (env.$elts.carousel.closest('.wpb_column').hasClass('vc_span8')){
		            env.$elts.content.children().each(function(){
			         	if (windowWidth < 480)
		            		$(this).css('width', Math.floor((env.$elts.carousel.closest('.vc_span8').outerWidth())-5));
		            	else {
				            $(this).css('width', Math.floor((env.$elts.carousel.closest('.vc_span8').outerWidth() / 2)-5));
				            if ($(this).closest('section').is('.recentProjects3')){
			            		$(this).width($(this).width()-5);
					        }
				        }
		            });
		            columns = true;
	            }
	            
	            if (env.$elts.carousel.closest('.wpb_column').hasClass('vc_span3')){
		            env.$elts.content.children().each(function(){
	            		$(this).css('width', Math.floor((env.$elts.carousel.closest('.vc_span3').outerWidth())-5));
		            });
		            columns = true;
	            }
	            
	            if (env.$elts.carousel.closest('.wpb_column').hasClass('vc_span9')){
		            env.$elts.content.children().each(function(){
		            	if (env.$elts.carousel.closest('section').is('.recentProjects4')){
			            	if (windowWidth < 480)
			            		$(this).css('width', Math.floor((env.$elts.carousel.closest('.vc_span9').outerWidth())-5));
			            	if (windowWidth < 768 && windowWidth > 479)
					            $(this).css('width', Math.floor((env.$elts.carousel.closest('.vc_span9').outerWidth() / 2)-5));
					        if (windowWidth > 767 && windowWidth < 960)
						        $(this).css('width', Math.floor((env.$elts.carousel.closest('.vc_span9').outerWidth() / 3)-5));
					        if (windowWidth > 959)
					        	$(this).css('width', Math.floor((env.$elts.carousel.closest('.vc_span9').outerWidth() / 3)-5));	
		            	} else {
			            	if (windowWidth < 480)
			            		$(this).css('width', Math.floor((env.$elts.carousel.closest('.vc_span9').outerWidth())-10));
			            	if (windowWidth < 768 && windowWidth > 479)
					            $(this).css('width', Math.floor((env.$elts.carousel.closest('.vc_span9').outerWidth() / 2)-10));
					        if (windowWidth > 767 && windowWidth < 960)
						        $(this).css('width', Math.floor((env.$elts.carousel.closest('.vc_span9').outerWidth() / 3)-10));
					        if (windowWidth > 959)
					        	$(this).css('width', Math.floor((env.$elts.carousel.closest('.vc_span9').outerWidth() / 3)-10));	
		            	}
		            });
		            columns = true;
	            }		        
	        }

            if (!columns){
            	
		        if (!env.$elts.carousel.closest('section').is('.recent_testimonials') && !env.$elts.carousel.closest('section').is('.shortcode-partners')){
		        	
		        	if (env.$elts.carousel.closest('section').is('.recentProjects3')){
			        	env.$elts.content.children().each(function(){
				            if (windowWidth < 480)
			            		$(this).css('width', Math.floor((env.$elts.carousel.closest('section').outerWidth())-10));
			            	if (windowWidth < 768 && windowWidth > 479)
					            $(this).css('width', Math.floor((env.$elts.carousel.closest('section').outerWidth() / 2)-10));
					        if (windowWidth > 767 && windowWidth < 960)
						        $(this).css('width', Math.floor((env.$elts.carousel.closest('section').outerWidth() / 3)-10));
					        if (windowWidth > 959)
					        	$(this).css('width', Math.floor((env.$elts.carousel.closest('section').outerWidth() / 4)-10));
			            });
		        	} else {
			    		env.$elts.content.children().each(function(){
			    			var factor = 0;
			    			if (env.widget) factor = 5;
				    		if (windowWidth < 480)
			            		$(this).css('width', Math.floor((env.$elts.carousel.closest('section').outerWidth())-factor));
			            	if (windowWidth < 768 && windowWidth > 479)
					            $(this).css('width', Math.floor((env.$elts.carousel.closest('section').outerWidth() / 2)-factor));
					        if (windowWidth > 767 && windowWidth < 960)
						        $(this).css('width', Math.floor((env.$elts.carousel.closest('section').outerWidth() / 3)-factor));
					        if (windowWidth > 959)
					        	$(this).css('width', Math.floor((env.$elts.carousel.closest('section').outerWidth() / 4)-factor));
			            });    	
		        	}
		        
		        } else {
		        	env.$elts.carousel.closest('section').children().wrapAll('<div class="sixteen columns"/>').removeAttr('style');
			     	env.$elts.content.children().each(function(){
				        if (env.$elts.carousel.closest('section').is('.shortcode-partners')){
					        if (windowWidth < 480)
			            		$(this).css('width', Math.floor((env.$elts.carousel.closest('section').outerWidth())-5));
			            	if (windowWidth < 768 && windowWidth > 479)
					            $(this).css('width', Math.floor((env.$elts.carousel.closest('section').outerWidth() / 2)-7));
					        if (windowWidth > 767 && windowWidth < 960)
						        $(this).css('width', Math.floor((env.$elts.carousel.closest('section').outerWidth() / 3)-12));
					        if (windowWidth > 959)
					        	$(this).css('width', Math.floor((env.$elts.carousel.closest('section').outerWidth() / 4)-12));
				        } 
				        if (env.$elts.carousel.closest('section').is('.recent_testimonials')){
					        if (windowWidth < 480)
			            		$(this).css('width', Math.floor((env.$elts.carousel.closest('section').outerWidth())-10));
			            	if (windowWidth < 768 && windowWidth > 479)
					            $(this).css('width', Math.floor((env.$elts.carousel.closest('section').outerWidth())-10));
					        if (windowWidth > 767 && windowWidth < 960)
						        $(this).css('width', Math.floor((env.$elts.carousel.closest('section').outerWidth())-16));
					        if (windowWidth > 959)
					        	$(this).css('width', Math.floor((env.$elts.carousel.closest('section').outerWidth() / 2)-15));
				        }
		            });  
		        }
            } else {
	            if (env.$elts.carousel.closest('section').is('.recent_testimonials')){
		            env.$elts.content.children().each(function(){
			            $(this).css('width', Math.floor((env.$elts.carousel.closest('section').outerWidth())-5)).css('margin-right','5px');
		            });
	            }
            }
            
            var ratio = .75;
            if (env.$elts.carousel.closest('section').is('.recentProjects3')){
	        	env.$elts.content.children().each(function(){
	        		if (!env.$elts.carousel.closest('section').is('.container')){
		        		$(this).css('width', $(this).width() - 5);	
	        		} else {
		        		$(this).css('width', $(this).width() - 5);	
	        		}
	        		$(this).height('auto');
	        		$(this).find('.ch-grid li ').css('height', Math.round($(this).width() * ratio));
	        		$(this).parents('.carousel-wrap').css('height',$(this).height());
		        });    
            }
            
            if (env.$elts.carousel.closest('section').is('.recentProjects4')){
	        	env.$elts.content.children().each(function(){
	        		if (!env.$elts.carousel.closest('section').is('.container')){
		        		$(this).css('width', $(this).width() - 11);	
	        		}
	        		$(this).find('li a').css('height', Math.round($(this).width() * ratio));
		        });    
            }  
            
            // Loader 
            env.$elts.loader = $('<div class="loader"></div>').css({'position':'absolute'});
            
            // Last visible step
            env.steps.last = env.steps.count - 1;

            
            // Pagination
            if (env.params.pagination) {
                initPagination(env);
            }
            
            // Prev Button
            if ($.isFunction(env.params.prevBtnInsertFn)) {
                env.$elts.prevBtn = env.params.prevBtnInsertFn(env.$elts);
            } else { 
                if (params.btnsPosition == "outside"){
                    env.$elts.prevBtn = $(params.prevBtn)[params.prevBtnInsert](env.$elts.carousel);
                } else {
                    env.$elts.prevBtn = $(params.prevBtn)[params.prevBtnInsert](env.$elts.wrap);
                }
            }
            
            // Next Button
            if ($.isFunction(env.params.nextBtnInsertFn)) {
                env.$elts.nextBtn = env.params.nextBtnInsertFn(env.$elts);
            } else {
                if (params.btnsPosition == "outside"){
                    env.$elts.nextBtn = $(params.nextBtn)[params.nextBtnInsert](env.$elts.carousel);
                } else {
                    env.$elts.nextBtn = $(params.nextBtn)[params.nextBtnInsert](env.$elts.wrap);
                }
            }
            
            if ($(window).width() < 401){
	            env.$elts.content.children().each(function(){
		            $(this).width(295);
	            });
            }
            
            // Add buttons classes / data
            env.$elts.nextBtn.addClass("carousel-control next carousel-next");
            env.$elts.prevBtn.addClass("carousel-control previous carousel-previous");
            
            // Last items to load in ajaxMode var
            env.lastItemsToLoad;
            
            // Bind events on next / prev buttons
            initButtonsEvents(env);
            
            // Bind events on focus for keyboard control
            env.$elts.carousel.attr('tabindex',0).add(env.$elts.carousel.children()).bind({
                focus : function(e){
                    $(document).bind('keypress', function(e){
                        switch (e.keyCode) {
                            case 39 : env.$elts.nextBtn.click(); break;
                            case 37 : env.$elts.prevBtn.click(); break;
                        }
                        switch (e.charCode) {
                            case 110 : env.$elts.nextBtn.click(); break;
                            case 112 : env.$elts.prevBtn.click(); break;
                        }
                    });
                }, 
                blur : function(){
                    $(document).unbind('keypress');
                }
            });
            
            // Address plugin
            initAddress(env);
            // On document load...
            $(function(){
                
                // Launch carousel initialization
                initCarousel(env);
                
                // Launch function added to "document ready" event
                $.each(env.launchOnLoad, function(i,fn){
                    fn();
                });
                
                // Launch autoslide
                if (env.params.autoSlide){
                    initAutoSlide(env);
                }
                
                // Control Slide Button
                if(params.stopSlideBtn == true){
                    env.$elts.stopSlideBtn = $('<button type="button" class="slide-control play">'+params.stopSlideTextPause+'</button>');
                    createBtnStopAutoslide(env);
                }
                
            });
            
            $(window).load(function(){
                
                // Launch carousel initialization
                initCarousel(env);
                
                // Launch function added to "document ready" event
                $.each(env.launchOnLoad, function(i,fn){
                    fn();
                });
                
                // Launch autoslide
                if (env.params.autoSlide){
                    initAutoSlide(env);
                }
                
                // Control Slide Button
                if(params.stopSlideBtn == true){
                    env.$elts.stopSlideBtn = $('<button type="button" class="slide-control play">'+params.stopSlideTextPause+'</button>');
                    createBtnStopAutoslide(env);
                }
                
            });
            
            if ($(this).parents(".rposts2").find(".pag-proj2_s2").length){
	   	    	$(this).parents('.rposts2').find('.pag-proj2_s2 .previous').click(function(){
		   	    	$(this).parents('.rposts2').find('.project_list_s2').children('.previous').click();
	   	    	}).addClass('jcarousel-prev jcarousel-prev-horizontal');
	   	    	$(this).parents('.rposts2').find('.pag-proj2_s2 .next').click(function(){
		   	    	$(this).parents('.rposts2').find('.project_list_s2').children('.next').click();
	   	    	}).addClass('jcarousel-next jcarousel-next-horizontal');
	   	    	$(this).find('.carousel-control').css('display','none');
		    } else {
	   	    	if ($(this).parents(".recentProjects3").find(".pag-proj2_s3").length){
		   	    	$(this).parents('.recentProjects3').find('.pag-proj2_s3 .previous').click(function(){
			        	$(this).parents('.recentProjects3').find('.project_list_s3').children('.previous').click();
		        	}).addClass('jcarousel-prev jcarousel-prev-horizontal');
		        	$(this).parents('.recentProjects3').find('.pag-proj2_s3 .next').click(function(){
			        	$(this).parents('.recentProjects3').find('.project_list_s3').children('.next').click();
		        	}).addClass('jcarousel-next jcarousel-next-horizontal');;
		   	    	$(this).find('.carousel-control').css('display','none');	   	    	
	   	    	} else {
		   	    	if ($(this).parents(".projects_container_s4").find(".pag-proj2_s4").length){
			   			$(this).parents('.projects_container_s4').find('.pag-proj2_s4 .previous').click(function(){
				   			$(this).parents('.projects_container_s4').find('.project_list_s4').children('.previous').click();
			   			}).addClass('jcarousel-prev jcarousel-prev-horizontal');
			   			$(this).parents('.projects_container_s4').find('.pag-proj2_s4 .next').click(function(){
				   			$(this).parents('.projects_container_s4').find('.project_list_s4').children('.next').click();
			   			}).addClass('jcarousel-next jcarousel-next-horizontal');
			   			$(this).find('.carousel-control').css('display','none');
		   	    	} else {
			   	    	if ($(this).parents(".shortcode-partners").length){
				   	    	$(this).parents('.shortcode-partners').find('.pag-proj_partners .previous').click(function(){
					        	$(this).parents(".shortcode-partners").find('.partners-carousel').children('.carousel-previous').click();
				        	}).addClass('jcarousel-prev jcarousel-prev-horizontal');
				        	$(this).parents('.shortcode-partners').find('.pag-proj_partners .next').click(function(){
					        	$(this).parents(".shortcode-partners").find('.partners-carousel').children('.carousel-next').click();
				        	}).addClass('jcarousel-next jcarousel-next-horizontal');
				   	    	$(this).find('.carousel-control').css('display','none');
			   	    	} else {
				   	    	if ($(this).parents(".shortcode-team").length){
						   	    	$(this).parents('.shortcode-team').find('.pag-proj_team .prevbutton').click(function(){
							        	$(this).parents(".shortcode-team").find('.team-carousel').children('.carousel-previous').click();
						        	}).addClass('jcarousel-prev jcarousel-prev-horizontal');
						        	$(this).parents('.shortcode-team').find('.pag-proj_team .nextbutton').click(function(){
							        	$(this).parents(".shortcode-team").find('.team-carousel').children('.carousel-next').click();
						        	}).addClass('jcarousel-next jcarousel-next-horizontal');
						   	    	$(this).find('.carousel-control').css('display','none');
				   	    	} else {
					   	    	if ($(this).parents(".recent_testimonials").length){
					   	    		$(this).parents(".recent_testimonials").addClass()
						   	    	$(this).parents('.recent_testimonials').find('.pag-testimonials .prevbutton').click(function(){
							        	$(this).parents(".recent_testimonials").find('.slideContent').children('.carousel-previous').click();
						        	}).addClass('jcarousel-prev jcarousel-prev-horizontal');
						        	$(this).parents('.recent_testimonials').find('.pag-testimonials .nextbutton').click(function(){
							        	$(this).parents(".recent_testimonials").find('.slideContent').children('.carousel-next').click();
						        	}).addClass('jcarousel-next jcarousel-next-horizontal');
						   	    	$(this).find('.carousel-control').css('display','none');
					   	    	}
				   	    	}
			   	    	}
		   	    	}
	   	    	}
		    }
            
        });
        
    };
    
    // Init carousel dimensions
    function initCarousel(env){
        //Set max Height with the highest element
        var $items = env.$elts.content.children();
        var $maxHeight = 0;
        
        $items.each(function () {
            $item = $(this);
            $itemHeight = $item.outerHeight();

            if ($itemHeight > $maxHeight) {
                $maxHeight = $itemHeight;
            }
        });
        
        if (env.params.verticalMargin > 0) {
            $maxHeight = $maxHeight + env.params.verticalMargin;
        }
        
        $items.height($maxHeight);
        // First item
        var $firstItem = env.$elts.content.children(":first");
        
        // Width 1/1 : Get default item width
        env.itemWidth = $firstItem.outerWidth() + parseInt($firstItem.css('margin-right'),10);
        
        // Width 2/3 : Define content width
        if (env.params.direction == "vertical"){
            env.contentWidth = env.itemWidth;
            
        } else {
            
            if (env.params.equalWidths) {
                env.contentWidth = env.itemWidth * env.steps.count;
                
            } else {
                env.contentWidth = (function(){
                    var totalWidth = 0;
                    
                    env.$elts.content.children().each(function(){
                        totalWidth += $(this).outerWidth();
                    });
                    
                    return totalWidth;
                })();
            }
        }
        
        // Width 3/3 : Set content width to container
        env.$elts.content.width(env.contentWidth);
        
        // Height 1/2 : Get default item height
        env.itemHeight = $maxHeight;
        
        // Height 2/2 : Set content height to container
        if (env.params.direction == "vertical") {
            env.$elts.content.css({
                height: env.itemHeight * env.steps.count + "px"
            });
            env.$elts.content.parent().css({
                height: env.itemHeight * env.params.dispItems + "px"
            });
        } else {
            env.$elts.content.parent().css({
                height: env.itemHeight + 10 + "px"
            });
        }
        
        // Update Next / Prev buttons state
        updateButtonsState(env);
    }
    
    // Next / Prev buttons events only
    function initButtonsEvents(env){ 
    	
    	env.$elts.nextBtn.add(env.$elts.prevBtn).add(env.$elts.content.closest('section').find('.previous').eq(0)).add(env.$elts.content.closest('section').find('.next').eq(0))
            .bind("enable", function(){
                
                var $this = $(this)
                    .unbind("click")
                    .bind("click", function(){
                        // Ajax init
                        if(env.params.ajaxMode && $this.is('.next') && getActivePageIndex(env) == (getPageTotal(env)-1) && !env.lastItemsToLoad) {
                            // Append content in ajax
                            ajaxLoad(env);
                            // Go to next page of the carousel
                            env.$elts.content.ajaxSuccess(function() {
                                                            
                            });
                        } else {                          
                            goToStep( env, getRelativeStep(env, ($this.is(".next")? "next" : "prev" )) );
                            
                            if(env.params.stopSlideBtn == true){
                                env.$elts.stopSlideBtn.trigger('pause');
                            } else {
                                stopAutoSlide(env);
                            }
                        }                       
                    })
                    .removeClass("disabled").removeAttr('disabled');
                
                // Combined classes (IE6 compatibility)
                if (env.params.combinedClasses) {
                    $this.removeClass("next-disabled previous-disabled").removeAttr("disabled");
                }
            })
            .bind("disable", function(){
                
                var $this = $(this).unbind("click").addClass("disabled").attr("disabled","disabled");
                
                // Combined classes (IE6 compatibility)
                if (env.params.combinedClasses) {
                    
                    if ($this.is(".next")) {
                        $this.addClass("next-disabled");
                        
                    } else if ($this.is(".previous")) {
                        $this.addClass("previous-disabled");
                        
                    }
                }
            })
            .hover(function(){
                $(this).toggleClass("hover");
            });
    };
    
    // Pagination
    function initPagination(env) {
            env.$elts.pagination = $('<div class="center-wrap"><div class="carousel-pagination"><p></p></div></div>')[((env.params.paginationPosition == "outside") ? "insertAfter" : "appendTo")](env.$elts.carousel).find("p");
            env.$elts.paginationBtns = $([]);

            env.$elts.content.children().each(function (i) {
                if (i % env.params.dispItems == 0) {
                    addPage(env, i);
                }
            });
    };
    
    // Add a page in pagintion (@ the end)
    function addPage(env, firststep) {
        if(env.params.pagination){
            env.$elts.paginationBtns = env.$elts.paginationBtns.add($('<a role="button"><span>' + env.params.tabLabel(env.$elts.paginationBtns.length + 1) + '</span></a>').data("firstStep", firststep))
            .appendTo(env.$elts.pagination);
            env.$elts.paginationBtns.slice(0, 1).addClass("active");
            env.$elts.paginationBtns.click(function (e) {
                goToStep(env, $(this).data("firstStep"));
                if(env.params.stopSlideBtn == true){
                    env.$elts.stopSlideBtn.trigger('pause');
                } else {
                    stopAutoSlide(env);
                }
            });
        }
    }
    
    // Address plugin
    function initAddress(env) {
        
        if (env.params.useAddress && $.isFunction($.fn.address)) {
            
            $.address
                .init(function(e) {
                    var pathNames = $.address.pathNames();
                    if (pathNames[0] === env.params.adressIdentifier && !!pathNames[1]) {
                        goToStep(env, pathNames[1]-1);
                    } else {
                        $.address.value('/'+ env.params.adressIdentifier +'/1');
                    }
                })
                .change(function(e) {
                    var pathNames = $.address.pathNames();
                    if (pathNames[0] === env.params.adressIdentifier && !!pathNames[1]) {
                        goToStep(env, pathNames[1]-1);
                    }
                });
        } else {
            env.params.useAddress = false;
        }
    };
    
    function goToStep(env, step) {
        
        // Callback
        env.params.callback(step);
        
        // Launch animation
        transition(env, step);
        
        // Update first step
        env.steps.first = step;
        
        // Update buttons status
        updateButtonsState(env);
        
        // Update address (jQuery Address plugin)
        if ( env.params.useAddress ) {
            $.address.value('/'+ env.params.adressIdentifier +'/' + (step + 1));
        }
        
    };
    
    // Get next/prev step, useful for autoSlide
    function getRelativeStep(env, position) {
        if (position == "prev") {
            if (!env.params.showEmptyItems) {
                if (env.steps.first == 0) {
                    return ((env.params.loop) ? (env.steps.count - env.params.dispItems) : false);
                } else {
                    return Math.max(0, env.steps.first - env.params.dispItems);
                }
            } else {
                if ((env.steps.first - env.params.dispItems) >= 0) {
                    return env.steps.first - env.params.dispItems;
                } else {
                    return ((env.params.loop) ? (env.steps.count - env.params.dispItems) : false);
                }
            }
        } else if (position == "next") {
        	var output = 0;
        	var itemsDisplayed = Math.floor(env.$elts.content.parent().width() / env.$elts.content.children().eq(0).width()) -1;
            if ((env.steps.first + env.params.dispItems) < env.steps.count - itemsDisplayed) {
                if (!env.params.showEmptyItems) {
                    output = Math.min(env.steps.first + env.params.dispItems, env.steps.count - env.params.dispItems);
                } else {
                    output = env.steps.first + env.params.dispItems;
                }
            } else {
                output = ((env.params.loop) ? 0 : false);
            }
            return output;
        }
    };
    
    // Animation
    function transition(env, step) {
        
        // Effect
        switch (env.params.effect){
            
            // No effect
            case "no":
                if (env.params.direction == "vertical"){
                    env.$elts.content.css("top", -(env.itemHeight * step) + "px");
                } else {
                    env.$elts.content.css("left", -(env.itemWidth * step) + "px");
                }
                break;
            
            // Fade effect
            case "fade":
                if (env.params.direction == "vertical"){
                    env.$elts.content.hide().css("top", -(env.itemHeight * step) + "px").fadeIn(env.params.animSpeed);
                } else {
                    env.$elts.content.hide().css("left", -(env.itemWidth * step) + "px").fadeIn(env.params.animSpeed);
                }
                break;
            
            // Slide effect
            default:
                
                function CallBackAnimate() {
                    env.params.completeAnimate(step);
                }

                if (env.params.direction == "vertical"){
                    env.$elts.content.stop().animate({
                        top : -(env.itemHeight * step) + "px"
                    }, env.params.animSpeed, env.params.slideEasing, CallBackAnimate);
                } else {
	                /* stop it you! */
                	var lefty = Math.abs(-(env.itemWidth * step)) - parseInt(env.$elts.content.children().css('margin-right'),10);
                	if (env.$elts.content.css('left') == "auto") lefty = 0;
                	if ( lefty < (env.$elts.content.width() - env.$elts.wrap.width())){
	                	env.$elts.content.stop().animate({
	                        left : -(env.itemWidth * step) + "px"
	                    }, env.params.animSpeed, env.params.slideEasing, CallBackAnimate);	
                	}
                }
                break;
        }
        
    };
    
    // Update all buttons state : disabled or not
    function updateButtonsState(env){
        
        if (getRelativeStep(env, "prev") !== false) {
            env.$elts.prevBtn.trigger("enable");
            env.$elts.content.parents('section').find('.previous').trigger('enable');
        } else {
            env.$elts.prevBtn.trigger("disable");
            env.$elts.content.parents('section').find('.previous').trigger('disable');
        }
        
        if (getRelativeStep(env, "next") !== false) {
            env.$elts.nextBtn.trigger("enable");
            env.$elts.content.parents('section').find('.next').trigger('enable');
        } else {
            env.$elts.nextBtn.trigger("disable");
            env.$elts.content.parents('section').find('.next').trigger('disable');
        }
        
        if (env.params.pagination){
            env.$elts.paginationBtns.removeClass("active")
            .filter(function(){             
                return ($(this).data("firstStep") == env.steps.first) 
            })
            .addClass("active");
        }
    };  
    
    // Launch Autoslide
    function initAutoSlide(env) {
        env.delayAutoSlide = window.setTimeout(function(){
            env.autoSlideInterval = window.setInterval(function(){
                goToStep( env, getRelativeStep(env, "next") );
            }, env.params.autoSlideInterval);
        }, env.params.delayAutoSlide);
    };
    
    // Stop autoslide
    function stopAutoSlide(env) {
        window.clearTimeout(env.delayAutoSlide);
        window.clearInterval(env.autoSlideInterval);
        env.params.delayAutoSlide = 0;
    };
    
    // Create button "stop autoslide"
    function createBtnStopAutoslide(env){
        var jButton = env.$elts.stopSlideBtn;
        
        jButton.bind({
            'play' : function(){
                initAutoSlide(env);
                jButton.removeClass('pause').addClass('play').html(env.params.stopSlideTextPause);
            }, 
            'pause' : function(){
                stopAutoSlide(env);
                jButton.removeClass('play').addClass('pause').html(env.params.stopSlideTextPlay);
            }
        });
        
        jButton.click(function(e){
            if(jButton.is('.play')){
                jButton.trigger('pause');
            } else if (jButton.is('.pause')){
                jButton.trigger('play');
            }
        });
        
        jButton.prependTo(env.$elts.wrap);
    };
    
    // Get total number of page in the carousel
    function getPageTotal(env) {
        return env.$elts.pagination.children().length;
    };
    
    function getActivePageIndex(env){
        return env.steps.first/env.params.dispItems;
    }
    
    // Load next page via Ajax
    function ajaxLoad(env) {
        // insert loader
        env.$elts.carousel.prepend(env.$elts.loader);
        
        // ajax call                
        $.ajax({
            url: env.params.ajaxUrl,
            dataType: 'json',
            success: function(data) {
                // set if the last item of the carousel have been loaded and add items to the carousel
                env.lastItemsToLoad = data.bLastItemsToLoad;
                $(env.$elts.content).append(data.shtml);
                
                // reinit count (number of items have changed after ajax call)
                env.steps = {
                    first: env.steps.first + env.params.dispItems,
                    count: env.$elts.content.children().length
                };
                env.steps.last = env.steps.count - 1;
                
                // rewrite carousel dimensions
                initCarousel(env);
                // rewrite/append pagination
                addPage(env,env.steps.first);
                
                // slide to next page
                goToStep( env, env.steps.first );
                if(env.params.stopSlideBtn == true){
                    env.$elts.stopSlideBtn.trigger('pause');
                } else {
                    stopAutoSlide(env);
                }
                
                // remove loader
                env.$elts.loader.remove();
            }
        });     
    }
    
})(jQuery);